﻿// 创建一个Http请求，用于异步请求处理
function createRequest() {
	var request;
	try {
		request = new XMLHttpRequest();
	} catch (trymicrosoft) {
		try {
			request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (othermicrosoft) {
			try {
				request = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (failed) {
				request = false;
			}
		}
	}

	return request;
}

// 创建文件队列完毕事件
function fileQueued(file) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget,this.customSettings.deleteImageUrl);
		progress.setUploadStatus("正在等待");
		progress.toggleCancel(true, this);

	} catch (ex) {
		this.debug(ex);
	}
}

// 文件队列错误
function fileQueueError(file, errorCode, message) {
	try {
		if (errorCode === SWFUpload.QUEUE_ERROR.QUEUE_LIMIT_EXCEEDED) {
			alert("您正在上传的文件过多.\n" + (message == 0 ? "您已达到上传限制." : "您最多能选择上传 " + message + " 文件."));
			return;
		}

		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setError();
		progress.setUploadStatus("上传失败");
		progress.toggleCancel(false);

		switch (errorCode) {
		case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
			progress.setStatus("文件过大");
			this.debug("错误代码: 文件尺寸过大, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
			progress.setStatus("无法上传零字节文件");
			this.debug("错误代码: 零字节文件, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
			progress.setStatus("不支持文件类型");
			this.debug("错误代码: 不支持的文件类型, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		default:
			if (file !== null) {
				progress.setStatus("未处理的错误");
			}
			this.debug("错误代码: " + errorCode + ", 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		}
	} catch (ex) {
        this.debug(ex);
    }
}

// 文件选择对话框关闭后的事件
function fileDialogComplete(numFilesSelected, numFilesQueued) {
	try {
		if (numFilesSelected > 0) {
			//document.getElementById(this.customSettings.cancelButtonId).disabled = false;
		}
		
		this.startUpload();
	} catch (ex)  {
        this.debug(ex);
	}
}

// 上传开始的事件
function uploadStart(file) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget,this.customSettings.deleteImageUrl);
		progress.setUploadStatus("正在上传");
		progress.toggleCancel(true, this);
	}
	catch (ex) {}
	
	return true;
}

// 上传进度事件
function uploadProgress(file, bytesLoaded, bytesTotal) {
	try {
		var percent = Math.ceil((bytesLoaded / bytesTotal) * 100);

		var progress = new FileProgress(file, this.customSettings.progressTarget,this.customSettings.deleteImageUrl);
		progress.setProgress(percent);
		progress.setUploadStatus("正在上传");
	} catch (ex) {
		this.debug(ex);
	}
}

// 上传成功事件
function uploadSuccess(file, serverData) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget,this.customSettings.deleteImageUrl);
		progress.setComplete();
		progress.setUploadStatus("上传成功");
		
		// 将上传后图片的路径设置到表单的隐藏域中
		var files=document.getElementById("hidUploadFiles").value;
		var thub_files=document.getElementById("hidUploadFilesThub").value;
		
		var thub_file="";
		var file="";
		if(serverData!=""){
			// 获取缩略图
			thub_file=serverData.split("|")[1];
			file=serverData.split("|")[0];
			progress.setUploadPhoto(thub_file);
			
			document.getElementById("hidUploadFiles").value=(files==""?file:files+";"+file);
			document.getElementById("hidUploadFilesThub").value=(thub_files==""?thub_file:thub_files+";"+thub_file);
		}
	} catch (ex) {
		this.debug(ex);
	}
}

// 上传发生错误事件
function uploadError(file, errorCode, message) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setError();
		progress.toggleCancel(false);
        progress.setUploadStatus("上传失败");

		switch (errorCode) {
		case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
			progress.setStatus("上传错误: " + message);
			this.debug("错误代码: HTTP错误, 文件名: " + file.name + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
			progress.setStatus("上传失败");
			this.debug("错误代码: 上传失败, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.IO_ERROR:
			progress.setStatus("服务器 (IO) 错误");
			this.debug("错误代码: IO 错误, 文件名: " + file.name + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
			progress.setStatus("安全错误");
			this.debug("错误代码: 安全错误, 文件名: " + file.name + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_LIMIT_EXCEEDED:
			progress.setStatus("超出上传限制.");
			this.debug("错误代码: 超出上传限制, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_VALIDATION_FAILED:
			progress.setStatus("无法验证.  跳过上传.");
			this.debug("错误代码: 文件验证失败, 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
			// If there aren't any files left (they were all cancelled) disable the cancel button
			if (this.getStats().files_queued === 0) {
				//document.getElementById(this.customSettings.cancelButtonId).disabled = true;
			}
			progress.setStatus("取消");
			progress.setCancelled();
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
			progress.setStatus("停止");
			break;
		default:
			progress.setStatus("未处理的错误: " + errorCode);
			this.debug("错误代码: " + errorCode + ", 文件名: " + file.name + ", 文件尺寸: " + file.size + ", 信息: " + message);
			break;
		}
	} catch (ex) {
        this.debug(ex);
    }
}

// 上传完毕事件
function uploadComplete(file) {
	if (this.getStats().files_queued === 0) {
		//document.getElementById(this.customSettings.cancelButtonId).disabled = true;
	}
}

// 队列上传完毕事件
function queueComplete(numFilesUploaded) {
	//var status = document.getElementById("divStatus");
	//status.innerHTML = numFilesUploaded + " 个文件已上传.";
}

// 删除文件
function deleteFile(file,swfUploadInstance){
	var request = createRequest();
	var url = swfUploadInstance.customSettings.delete_url + "?filepath=" + file;
	request.open("GET", url, true);
	request.send(null);
}