﻿<%
'//  缩略图生成函数 Code By Shaoyun
'//  参数：生成文件全路径、保存文件全路径、限定宽度、限定高度、生成方式
'//  调用示例
'//  filepath="images/"
'//  savepath="thumbs/"
'//  srcfile="4.jpg"
'//  destfile="s10.jpg"
'//  srcfile=Server.MapPath(filepath & srcfile)
'//  destfile=Server.MapPath(savepath & destfile)
'//  call makethumb(srcfile,destfile,200,120,3)
function MakeThumb(fileName,saveName,limitW,limitH,nType)
  if not(limitW>0 or limitH>0) then exit function
  Dim ojpg,oh,ow
  Set ojpg = Server.CreateObject("Persits.Jpeg")
  ojpg.open fileName
  oh = ojpg.OriginalHeight
  ow = ojpg.OriginalWidth
  select case nType
  case 0
    '限定宽高
    if limitW>0 and limitH>0 then
      ojpg.width=limitW
      ojpg.height=limitH
    end if
  case 1
    '只限定宽度，高度按比例
    if limitW>0 then
      ojpg.width=limitW
      ojpg.height=oh/ow*limitW
    end if
  case 2
    '只限定高度，宽度按比例
    if limitH>0 then
      ojpg.height=limitH
      ojpg.width=ow/oh*limitH
    end if
  case 3
    '按限定的宽高比裁切
    if limitW>0 and limitH>0 then
      Dim lheight:lheight=oh*limitW/ow
      If lheight<limitH Then
        ojpg.Height = limitH
        ojpg.Width = ow*ojpg.Height/oh
      Else
        ojpg.width = limitW
        ojpg.Height = oh*ojpg.width/ow
      End if
      ojpg.Crop 0, 0,limitW,limitH
    End If
  case else
    exit function
  end select
  ojpg.Quality = 90
  ojpg.save saveName
  Set ojpg = nothing
end function
 
'****************************************************
'函数名：ThumbnailImg
'作 用：制作图片的缩略图
'参 数：ImgUrl 原图地址
' ImgWidth 新图的宽
' Imgheight 新图的高
' newImgurl 新图的存放地址
'****************************************************
Sub ThumbnailImg(Imgurl,ImgWidth,Imgheight,newImgurl)
Dim Jpeg ''''//声明变量
If instr(imgUrl,":\")=0 Then imgUrl = Server.MapPath(imgUrl) 
If instr(newImgurl,":\")=0 Then newImgurl = Server.MapPath(newImgurl) 
Set Jpeg = Server.CreateObject("Persits.jpeg") ''''//调用组件
Jpeg.Open Imgurl ''''//原图位置
If ImgWidth<>"" and Imgheight="" Then Imgheight = ImgWidth*Jpeg.OriginalHeight / Jpeg.OriginalWidth 
If Imgheight<>"" and ImgWidth="" Then ImgWidth = Imgheight*Jpeg.OriginalWidth / Jpeg.OriginalHeight 
Jpeg.Width = ImgWidth ''''//设图片宽度
Jpeg.Height = Imgheight ''''//设图片高度
Jpeg.Sharpen 1, 130 ''''//设定锐化效果
Jpeg.Save newImgurl ''''//生成缩略图位置及名称
Set Jpeg = Nothing ''''//注销组件，释放资源
End Sub
'调用示例
'call ThumbnailImg("1.jpg",100,100,"2.jpg")
%>